﻿HexMessage = LibStub("AceAddon-3.0"): NewAddon("HexMessage", "AceEvent-3.0", "AceTimer-3.0")
local hexmessage_opt = {
	name = "HexMessage",
	handler = HexMessage,
	type = 'group',
	args = {
		on = {
			type = 'input',
			name = 'Turn Hex Encoding ON',
			desc = 'Turn Hex Encoding ON',
			set = 'ToggleOn',
			get = 'dummyfunc',
		},
		off = {
			type = 'input',
			name = 'Turn Hex Encoding OFF',
			desc = 'Turn Hex Encoding OFF',
			set = 'ToggleOff',
			get = 'dummyfunc',
		},
	},
}
DEFAULT_CHAT_FRAME:AddMessage("HexMessage loaded.");

function HexMessage:TranslateToHex(input)
	input = string.gsub(input, " ", "_#_TWO_#__#_ZERO_#_ ");
	input = string.gsub(input, "0", "_#_THREE_#__#_ZERO_#_ ");
	input = string.gsub(input, "1", "_#_THREE_#__#_ONE_#_ ");
	input = string.gsub(input, "2", "_#_THREE_#__#_TWO_#_ ");
	input = string.gsub(input, "3", "_#_THREE_#__#_THREE_#_ ");
	input = string.gsub(input, "4", "_#_THREE_#__#_FOUR_#_ ");
	input = string.gsub(input, "5", "_#_THREE_#__#_FIVE_#_ ");
	input = string.gsub(input, "6", "_#_THREE_#__#_SIX_#_ ");
	input = string.gsub(input, "7", "_#_THREE_#__#_SEVEN_#_ ");
	input = string.gsub(input, "8", "_#_THREE_#__#_EIGHT_#_ ");
	input = string.gsub(input, "9", "_#_THREE_#__#_NINE_#_ ");
	input = string.gsub(input, "_#_ZERO_#_", "0");
	input = string.gsub(input, "_#_ONE_#_", "1");
	input = string.gsub(input, "_#_TWO_#_", "2");
	input = string.gsub(input, "_#_THREE_#_", "3");
	input = string.gsub(input, "_#_FOUR_#_", "4");
	input = string.gsub(input, "_#_FIVE_#_", "5");
	input = string.gsub(input, "_#_SIX_#_", "6");
	input = string.gsub(input, "_#_SEVEN_#_", "7");
	input = string.gsub(input, "_#_EIGHT_#_", "8");
	input = string.gsub(input, "_#_NINE_#_", "9");
	input = string.gsub(input, "a", "61 ");
	input = string.gsub(input, "b", "62 ");
	input = string.gsub(input, "c", "63 ");
	input = string.gsub(input, "d", "64 ");
	input = string.gsub(input, "e", "65 ");
	input = string.gsub(input, "f", "66 ");
	input = string.gsub(input, "g", "67 ");
	input = string.gsub(input, "h", "68 ");
	input = string.gsub(input, "i", "69 ");
	input = string.gsub(input, "j", "6a ");
	input = string.gsub(input, "k", "6b ");
	input = string.gsub(input, "l", "6c ");
	input = string.gsub(input, "m", "6d ");
	input = string.gsub(input, "n", "6e ");
	input = string.gsub(input, "o", "6f ");
	input = string.gsub(input, "p", "70 ");
	input = string.gsub(input, "q", "71 ");
	input = string.gsub(input, "r", "72 ");
	input = string.gsub(input, "s", "73 ");
	input = string.gsub(input, "t", "74 ");
	input = string.gsub(input, "u", "75 ");
	input = string.gsub(input, "v", "76 ");
	input = string.gsub(input, "w", "77 ");
	input = string.gsub(input, "x", "78 ");
	input = string.gsub(input, "y", "79 ");
	input = string.gsub(input, "z", "7a ");
	input = string.gsub(input, "A", "41 ");
	input = string.gsub(input, "B", "42 ");
	input = string.gsub(input, "C", "43 ");
	input = string.gsub(input, "D", "44 ");
	input = string.gsub(input, "E", "45 ");
	input = string.gsub(input, "F", "46 ");
	input = string.gsub(input, "G", "47 ");
	input = string.gsub(input, "H", "48 ");
	input = string.gsub(input, "I", "49 ");
	input = string.gsub(input, "J", "4a ");
	input = string.gsub(input, "K", "4b ");
	input = string.gsub(input, "L", "4c ");
	input = string.gsub(input, "M", "4d ");
	input = string.gsub(input, "N", "4e ");
	input = string.gsub(input, "O", "4f ");
	input = string.gsub(input, "P", "50 ");
	input = string.gsub(input, "Q", "51 ");
	input = string.gsub(input, "R", "52 ");
	input = string.gsub(input, "S", "53 ");
	input = string.gsub(input, "T", "54 ");
	input = string.gsub(input, "U", "55 ");
	input = string.gsub(input, "V", "56 ");
	input = string.gsub(input, "W", "57 ");
	input = string.gsub(input, "X", "58 ");
	input = string.gsub(input, "Y", "59 ");
	input = string.gsub(input, "Z", "5a ");
	input = string.gsub(input, "%[", "5b ");
	input = string.gsub(input, "\\", "5c ");
	input = string.gsub(input, "%]", "5d ");
	input = string.gsub(input, "%^", "5e ");
	input = string.gsub(input, "_", "5f ");
	input = string.gsub(input, "`", "60 ");
	input = string.gsub(input, "@", "40 ");
	input = string.gsub(input, "%:", "3a ");
	input = string.gsub(input, ";", "3b ");
	input = string.gsub(input, "<", "3c ");
	input = string.gsub(input, "=", "3d ");
	input = string.gsub(input, ">", "3e ");
	input = string.gsub(input, "%?", "3f ");
	input = string.gsub(input, "!", "21 ");
	input = string.gsub(input, "\"", "22 ");
	input = string.gsub(input, "#", "23 ");
	input = string.gsub(input, "%$", "24 ");
	input = string.gsub(input, "%%", "25 ");
	input = string.gsub(input, "&", "26 ");
	input = string.gsub(input, "'", "27 ");
	input = string.gsub(input, "%(", "28 ");
	input = string.gsub(input, "%)", "29 ");
	input = string.gsub(input, "%*", "2a ");
	input = string.gsub(input, "%+", "2b ");
	input = string.gsub(input, "%,", "2c ");
	input = string.gsub(input, "%-", "2d ");
	input = string.gsub(input, "%.", "2e ");
	input = string.gsub(input, "/", "2f ");
	input = string.gsub(input, "§", "a7 ");
	input = string.gsub(input, "´", "b4 ");
	return input
end

function HexMessage:TranslateFromHex(input)
	input = string.gsub(input, "b4 ", "´");
	input = string.gsub(input, "a7 ", "§");
	input = string.gsub(input, "2f ", "/");
	input = string.gsub(input, "2e ", "%.");
	input = string.gsub(input, "2d ", "%-");
	input = string.gsub(input, "2c ", "%,");
	input = string.gsub(input, "2b ", "%+");
	input = string.gsub(input, "2a ", "%*");
	input = string.gsub(input, "29 ", "%)");
	input = string.gsub(input, "28 ", "%(");
	input = string.gsub(input, "27 ", "'");
	input = string.gsub(input, "26 ", "&");
	input = string.gsub(input, "25 ", "%%");
	input = string.gsub(input, "24 ", "%$");
	input = string.gsub(input, "23 ", "#");
	input = string.gsub(input, "22 ", "\"");
	input = string.gsub(input, "21 ", "!");
	input = string.gsub(input, "3f ", "%?");
	input = string.gsub(input, "3e ", ">");
	input = string.gsub(input, "3d ", "=");
	input = string.gsub(input, "3c ", "<");
	input = string.gsub(input, "3b ", ";");
	input = string.gsub(input, "3a ", "%:");
	input = string.gsub(input, "40 ", "@");
	input = string.gsub(input, "60 ", "`");
	input = string.gsub(input, "5f ", "_");
	input = string.gsub(input, "5e ", "%^");
	input = string.gsub(input, "5d ", "%]");
	input = string.gsub(input, "5c ", "\\");
	input = string.gsub(input, "5b ", "%[");
	input = string.gsub(input, "5a ", "Z");
	input = string.gsub(input, "59 ", "Y");
	input = string.gsub(input, "58 ", "X");
	input = string.gsub(input, "57 ", "W");
	input = string.gsub(input, "56 ", "V");
	input = string.gsub(input, "55 ", "U");
	input = string.gsub(input, "54 ", "T");
	input = string.gsub(input, "53 ", "S");
	input = string.gsub(input, "52 ", "R");
	input = string.gsub(input, "51 ", "Q");
	input = string.gsub(input, "50 ", "P");
	input = string.gsub(input, "4f ", "O");
	input = string.gsub(input, "4e ", "N");
	input = string.gsub(input, "4d ", "M");
	input = string.gsub(input, "4c ", "L");
	input = string.gsub(input, "4b ", "K");
	input = string.gsub(input, "4a ", "J");
	input = string.gsub(input, "49 ", "I");
	input = string.gsub(input, "48 ", "H");
	input = string.gsub(input, "47 ", "G");
	input = string.gsub(input, "46 ", "F");
	input = string.gsub(input, "45 ", "E");
	input = string.gsub(input, "44 ", "D");
	input = string.gsub(input, "43 ", "C");
	input = string.gsub(input, "42 ", "B");
	input = string.gsub(input, "41 ", "A");
	input = string.gsub(input, "7a ", "z");
	input = string.gsub(input, "79 ", "y");
	input = string.gsub(input, "78 ", "x");
	input = string.gsub(input, "77 ", "w");
	input = string.gsub(input, "76 ", "v");
	input = string.gsub(input, "75 ", "u");
	input = string.gsub(input, "74 ", "t");
	input = string.gsub(input, "73 ", "s");
	input = string.gsub(input, "72 ", "r");
	input = string.gsub(input, "71 ", "q");
	input = string.gsub(input, "70 ", "p");
	input = string.gsub(input, "6f ", "o");
	input = string.gsub(input, "6e ", "n");
	input = string.gsub(input, "6d ", "m");
	input = string.gsub(input, "6c ", "l");
	input = string.gsub(input, "6b ", "k");
	input = string.gsub(input, "6a ", "j");
	input = string.gsub(input, "69 ", "i");
	input = string.gsub(input, "68 ", "h");
	input = string.gsub(input, "67 ", "g");
	input = string.gsub(input, "66 ", "f");
	input = string.gsub(input, "65 ", "e");
	input = string.gsub(input, "64 ", "d");
	input = string.gsub(input, "63 ", "c");
	input = string.gsub(input, "62 ", "b");
	input = string.gsub(input, "61 ", "a");
	input = string.gsub(input, "9", "_#_NINE_#_");
	input = string.gsub(input, "8", "_#_EIGHT_#_");
	input = string.gsub(input, "7", "_#_SEVEN_#_");
	input = string.gsub(input, "6", "_#_SIX_#_");
	input = string.gsub(input, "5", "_#_FIVE_#_");
	input = string.gsub(input, "4", "_#_FOUR_#_");
	input = string.gsub(input, "3", "_#_THREE_#_");
	input = string.gsub(input, "2", "_#_TWO_#_");
	input = string.gsub(input, "1", "_#_ONE_#_");
	input = string.gsub(input, "0", "_#_ZERO_#_");
	input = string.gsub(input, "_#_THREE_#__#_NINE_#_ ", "9");
	input = string.gsub(input, "_#_THREE_#__#_EIGHT_#_ ", "8");
	input = string.gsub(input, "_#_THREE_#__#_SEVEN_#_ ", "7");
	input = string.gsub(input, "_#_THREE_#__#_SIX_#_ ", "6");
	input = string.gsub(input, "_#_THREE_#__#_FIVE_#_ ", "5");
	input = string.gsub(input, "_#_THREE_#__#_FOUR_#_ ", "4");
	input = string.gsub(input, "_#_THREE_#__#_THREE_#_ ", "3");
	input = string.gsub(input, "_#_THREE_#__#_TWO_#_ ", "2");
	input = string.gsub(input, "_#_THREE_#__#_ONE_#_ ", "1");
	input = string.gsub(input, "_#_THREE_#__#_ZERO_#_ ", "0");
	input = string.gsub(input, "_#_TWO_#__#_ZERO_#_ ", " ");
	return input
end

function HexMessage:OnInitialize()
	LibStub("AceConfig-3.0"):RegisterOptionsTable("HexMessage", hexmessage_opt, {"hexmessage", "hex"});
end

function HexMessage:CHAT_MSG_ADDON(event, prefix, msg, channel, author)
	if prefix == "HexMessageRequest" then
		local rev = string.match("$Revision: 11 $", "%d+");
		SendAddonMessage("HexMessageRevision", rev, "WHISPER", author);
	elseif prefix == "HexMessageRevision" then
		if tonumber(msg) < 6 then
			SendAddonMessage("HexMessageIncompatible", " ", "WHISPER", author);
		end
	elseif prefix == "HexMessageIncompatible" then
		RaidNotice_AddMessage(RaidWarningFrame, "Your version of HexMessage is no longer compatible to the newest version. Please visit curse.com and update to the newest version", {r=1, g=0.3, b=0})
	end
end

function HexMessage:IncompatibleCheck()
	if GetNumRaidMembers() > 0 then
		SendAddonMessage("HexMessage", "Your version of HexMessage is no longer compatible to the newest version. Please visit curse.com and update to the newest version", "RAID");
		SendAddonMessage("HexMessageRequest", " ", "RAID");
	end
	if GetNumPartyMembers() > 0 and GetNumRaidMembers() == 0 then
		SendAddonMessage("HexMessage", "Your version of HexMessage is no longer compatible to the newest version. Please visit curse.com and update to the newest version", "PARTY");
		SendAddonMessage("HexMessageRequest", " ", "PARTY");
	end
	HexMessage:ScheduleTimer("IncompatibleCheck", 60);
end

function HexMessage:OnEnable()
	ChatFrame_AddMessageEventFilter("CHAT_MSG_SAY", HexMessage.ChatFilter);
	ChatFrame_AddMessageEventFilter("CHAT_MSG_BATTLEGROUND", HexMessage.ChatFilter);
	ChatFrame_AddMessageEventFilter("CHAT_MSG_BATTLEGROUND_LEADER", HexMessage.ChatFilter);
	ChatFrame_AddMessageEventFilter("CHAT_MSG_CHANNEL", HexMessage.ChatFilter);
	ChatFrame_AddMessageEventFilter("CHAT_MSG_GUILD", HexMessage.ChatFilter);
	ChatFrame_AddMessageEventFilter("CHAT_MSG_OFFICER", HexMessage.ChatFilter);
	ChatFrame_AddMessageEventFilter("CHAT_MSG_PARTY", HexMessage.ChatFilter);
	ChatFrame_AddMessageEventFilter("CHAT_MSG_RAID", HexMessage.ChatFilter);
	ChatFrame_AddMessageEventFilter("CHAT_MSG_RAID_LEADER", HexMessage.ChatFilter);
	ChatFrame_AddMessageEventFilter("CHAT_MSG_WARNING", HexMessage.ChatFilter);
	ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER", HexMessage.ChatFilter);
	ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER_INFORM", HexMessage.ChatFilter);
	ChatFrame_AddMessageEventFilter("CHAT_MSG_YELL", HexMessage.ChatFilter);
	ChatFrame_AddMessageEventFilter("CHAT_MSG_SAY", HexMessage.ChatFilter);
	HexMessage:IncompatibleCheck();
	HexMessage:RegisterEvent("CHAT_MSG_ADDON");
end

function HexMessage:GetOriginalMessage(msg)
	msg = string.gsub(msg, "%[Hexadecimal%] ", "");
	msg = HexMessage:TranslateFromHex(msg);
	return msg
end

function HexMessage:ChatFilter(event, msg, author, ...)
	if msg:find("%[Hexadecimal%] ") then
		msg2 = string.gsub(msg, "%[Hexadecimal%] ", "");
		msg2 = "[Hexadecimal] "..msg2;
		if msg ~= msg2 then
			return false, msg, author, ...
		end
		msg = string.gsub(msg, "%[Hexadecimal%] ", "");
		msg = HexMessage:TranslateFromHex(msg);
		msg = "[Hexadecimal] "..msg;
		return false, msg, author, ...
	end
end

function HexMsg_SendChatMessage(msg, chattype, language, channel)
	msg = HexMessage:TranslateToHex(msg);
	if chattype == "EMOTE" then
		return
	end
	msg = "[Hexadecimal] "..msg;
	local len = strlen(msg);
	if len > 255 then
		print("Message is too long to convert to Hexadecimal (due to serverside restrictions of the length of messages). Please shorten your message to 80 characters or less.");
	else
		hexmsg_oldsendchatmessage(msg, chattype, language, channel);
	end
end

function HexMessage:dummyfunc()
	return nil
end

function HexMessage:ToggleOn(info, input)
	hexmsg_oldsendchatmessage = SendChatMessage;
	SendChatMessage = HexMsg_SendChatMessage;
	print("HexMessage turned ON");
end

function HexMessage:ToggleOff(info, input)
	SendChatMessage = hexmsg_oldsendchatmessage;
	print("HexMessage turned OFF");
end
